#!/usr/bin/perl
# indexsoft Site-UP ready web site
# (c) indexsoft 2001-2004
# http://www.indexsoft.com

$|++;
use CGI;
# use CGI::Carp qw(fatalsToBrowser);

# indexsoft Site-UP ready web site version
$VERSION = '1.0 stable';

# web site initial variables do not change them here.
# use .surwsini post initial configuration file instead
$PERLINCDIR = '_perl';
$HTMLINCDIR = '_html';
$HTMLINCCURDIR = 0;
$PLUGDIR = '_plug';
$PERLFILES = 'px';

# Cookies
foreach my $line (split(/; /, $ENV{'HTTP_COOKIE'}))
{ my ($name, $value) = split (/=/, $line); %COOKIES -> {"$name"} = "$value"; }

# Read GET, POST
$MULTIPARTQUERY = new CGI;
if ($ENV{'QUERY_STRING'})
{
	foreach my $line($MULTIPARTQUERY->url_param)
	{ %P -> {"$line"} = join("\0", $MULTIPARTQUERY->url_param("$line")); $P{"$line"} =~ s/\r//g; }
}
foreach my $line($MULTIPARTQUERY->param)
{ %P -> {"$line"} = join("\0", $MULTIPARTQUERY->param("$line")); $P{"$line"} =~ s/\r//g; }

# wrong surws.cgi calls
die if $ENV{REQUEST_URI} =~ '^/surws.cgi';
die if !$P{siteup_content_file};

# Query string
$QUERYSTRING = $ENV{'QUERY_STRING'}; $QUERYSTRING =~ s/^[^&]+&{0,1}//;

# Web site URL
$WEBSITEURL = "http://$ENV{'HTTP_HOST'}";

# directory where web site is installed
($INSTALLDIR) = $ENV{'SCRIPT_FILENAME'} =~ /^(.*)(\\|\/).*/;
$ENV{'WINDIR'}?($DS = '\\'):($DS = '/');
$INSTALLDIR =~ s/(\\|\/)/$DS/g;

# change document root dir
chdir $INSTALLDIR;

# current directory
$CURRENTDIR = $INSTALLDIR;
if ($P{'siteup_content_file'} =~ /^(.*)(\\|\/)(.*)$/)
{ $CURRENTDIR .= "$DS$1"; $CURRENTDIR =~ s/(\\|\/)/$DS/g; }

# current file and URL
$THISFILE = "$INSTALLDIR$DS$P{'siteup_content_file'}"; $THISFILE =~ s/(\\|\/)/$DS/g;
$THISFILENAME = $THISFILE; $THISFILENAME =~ s/^(.*)(\\|\/)//;
$THISURL = $ENV{'REQUEST_URI'}; $THISURL =~ s/\?.*$//; 

# remove $P{'siteup_content_file'}
delete $P{'siteup_content_file'};

# load web-site post initial configuration file .surwsini if exist
&RequireAndParseFile("$INSTALLDIR$DS.surwsini") if -e "$INSTALLDIR$DS.surwsini";

# list of the directories from the document root directory to the current
push (@DIRLIST, $INSTALLDIR);
foreach my $dir(split(/\\|\//, substr($CURRENTDIR,length($INSTALLDIR)+1)))
{ push (@DIRLIST, $DIRLIST[$#DIRLIST]."$DS$dir"); }

# directories with HTML templates and perl modules
foreach my $dir(reverse(@DIRLIST))
{
	push(@INCHTML, $dir) if ($dir eq $CURRENTDIR or $HTMLINCCURDIR);
	foreach (split(/\,/, $HTMLINCDIR)) { push (@INCHTML, "$dir$DS$_"); }
	foreach (split(/\,/, $PERLINCDIR)) { push (@INC, "$dir$DS$_"); }
}

# load plugins and collect errors
opendir (DIR, "$INSTALLDIR$DS$PLUGDIR");
while (my $plugin = readdir(DIR))
{
	if ($plugin =~ /\.cfg$/ or $plugin =~ /\.pl$/)
	{ next if -d "$CURRENTDIR$DS$PLUGDIR$DS$plugin"; push (@PLUGINS, "$INSTALLDIR$DS$PLUGDIR$DS$plugin"); }
}
closedir(DIR);
foreach my $plugin(sort(@PLUGINS)) { ($plugin =~ /\.pl$/)?(&RequireAndParseFile($plugin)):(&ReadAndParseFile($plugin)) }

# read and parse directory configuration files
foreach my $dir(@DIRLIST)
{
	if ($Language::LANGUAGE and -e "$dir$DS($Language::LANGUAGE).surwsdir")
	{ &RequireAndParseFile("$dir$DS($Language::LANGUAGE).surwsdir") }
	elsif (-e "$dir$DS.surwsdir")
	{ &RequireAndParseFile("$dir$DS.surwsdir") }
}

# display perl errors if any
for (0..$#PERLERRORS) { $CONTENT_FILE .= "<p>[%PUT:PERLERRORS[$_]%]</p>" };

# read or require requested file
# perl file, REQ used
if (grep($THISFILENAME =~ /\.$_$/, split(/,/, $PERLFILES)))
{
	(-e $THISFILE)
	# REQ this file
	?($CONTENT_FILE .= &EvalDirective("REQ:$THISFILE"))
	# search perl file and REQ
	:($CONTENT_FILE .= &EvalDirective("REQ:$THISFILENAME"))
}
# html file, INC used
else { $CONTENT_FILE .= &EvalDirective("INC:$THISFILENAME") }

# parse and print whole page
print &EvalDirective("INC:$SITEUPSKIN");
print &EvalDirective("INC:$SiteUP::TEMPLATES{bottomlinks}|".&FindHTMLFile($SITEUPSKIN)) if $SiteUP::QUICKEDIT;
print &EvalDirective("INC:$SiteUP::TEMPLATES{enableqedit}") if !$SiteUP::QUICKEDIT and grep($ENV{REMOTE_ADDR} eq $_, split(/,/, $SiteUP::ALLOWIP));
# $ENV{REMOTE_ADDR} =~ /^($SiteUP::ALLOWIP)$/;

###################################################
sub Parse
{
	my ($content, @params) = @_;
	return 'infinitely recursion error' if $PARSED >= 100;
	++$PARSED;
	# eval directives
	# only [%%]
	#	1 while $content =~ s/\[%(([^%]*(?<!\[)%*(?!\])[^%]*)+)%\]/&EvalDirective($1,@params)/se;
	#	[%[]%] or <%[]%> remove directives
	#	1 while $content =~ s/(\[|\<)%\[(.*?)\]%(\]|\>)/&RemoveDirectives($2)/se;
	# [%%] or <%%> 
	1 while $content =~ s/(\[|\<)%(([^%]*(?<!(\[|\<))%*(?!(\]|\>))[^%]*)+)%(\]|\>)/&EvalDirective($2,@params)/se;
	--$PARSED;
	return $content;
}
sub EvalDirective
{
	my ($directive, @params) = @_;
	my ($file, $filename, $filenamejs) = ();
	# remove comments [%#...%]
	return $directive if $directive =~ s/^#.*$//s;

	# eval if-else expression with variable [%IF:$variable??true::false%]
	return $directive if $directive =~ s/^IF:\$(.*)\?\?(.*)::(.*)$/((eval '$'."$1")?($2):($3))/se;
	# eval if-else expression [%IF:condition??true::false%]
	return $directive if $directive =~ s/^IF:(.*)\?\?(.*)::(.*)$/(($1)?($2):($3))/se;
	# count [%CNT:digit??one::two::three..........%]
	return $directive if $directive =~ s/^CNT:(.*)\?\?(.*)/((($cnt,$blk)=($1,$2) and $cnt and $cnt=~\/^\d+$\/ and split('::', $blk))?($_[$cnt-1]):(''))/se;

	# perl eval expression [%EVL:expression%]
	return $directive if $directive =~ s/^EVL:(.+)$/(eval $1).$@/se and (($@)?(push (@PERLERRORS, $@)):(1));

	# insert params [%0%]... from @params
	return $directive if $directive =~ s/^(\d+)$/$params[$1]/;
	### insert params [%`0`%]... from @params. first replace commas 
	### return $directive if $directive =~ s/^\`(\d+)\`$/&ReplaceCommas($params[$1])/se;
	### insert params [%{0}%] or [%(0)%]... from @params. first HTML format them
	### return $directive if $directive =~ s/^{(\d+)}$/&HTMLFormating($params[$1])/e;
	### return $directive if $directive =~ s/^\((\d+)\)$/&HTMLFormating($params[$1])/e;
	# insert params [%{0}%]... from @params. first HTML format them
	return $directive if $directive =~ s/^{(\d+)}$/&HTMLFormating($params[$1])/e;

	# replace commas [%'block'%] with HTML equivalents
	return $directive if $directive =~ s/^\'(.*)\'$/&ReplaceCommas($1)/se;
	### HTML formatting block [%{block}%] or [%(block)%]
	### return $directive if $directive =~ s/^\((.*)\)$/&HTMLFormating($1)/se;
	### return $directive if $directive =~ s/^{(.*)}$/&HTMLFormating($1)/se;
	# HTML formatting block [%(block)%]
	return $directive if $directive =~ s/^\((.*)\)$/&HTMLFormating($1)/se;

	# is variables defined or not zero [%DEF:var%] or [%*var%]
	return $directive if $directive =~ s/^(DEF:|\*)(.+)$/((eval '$'."$2")?(1):(0))/e;
	# insert variables [%INS:var%] or [%$var%]
	return $directive if $directive =~ s/^(INS:|\$)(.+)$/(eval '$'."$2").$@/e and (($@)?(push (@PERLERRORS, $@)):(1));
	# insert variables no parse [%PUT:var%] or [%\$var%]
	return $directive if $directive =~ s/^(PUT:|\\\$)(.+)$/&HTMLFormating((eval '$'."$2").$@)/e and (($@)?(push (@PERLERRORS, $@)):(1));
	# set variables [%SET:var=value%]
	return $directive if $directive =~ s/^SET:([^=]+)=(.*)$/(eval('$'."$1".'=$2')?(''):($@))/se and (($@)?(push (@PERLERRORS, $@)):(1));
	# addition variables [%ADD:var=value%]
	return $directive if $directive =~ s/^ADD:([^=]+)=(.*)$/(eval('$'."$1".'.=$2')?(''):($@))/se and (($@)?(push (@PERLERRORS, $@)):(1));

	# download and insert document via HTTP [%GET:http://url%]
	return $directive if $directive =~ s/^GET:(.+)$/&GetAndParseUrl($1)/e;
	# download and insert document via HTTP w/o parsing [%FET:http://url%]
	return $directive if $directive =~ s/^FET:(.+)$/&GetUrlNoParse($1)/e;

	# run external file [%RUN:file_name_or_command%]
	return $directive if $directive =~ s/^RUN:(.+)$/&RunAndParseFile($1)/e;
	# run external file w/o parsing [%EXE:file_name_or_command%]
	return $directive if $directive =~ s/^EXE:(.+)$/&RunFileNoParse($1)/e;

	#
	# include files [%INC:file_name|params_divided_by_commas%]
	return $directive if $directive =~ s!^INC:([^|]+)\|?(.*)$!(
		# Site-UP links?
		(
			($file = $1) && # file w/o path
			((@params = split(/(?<\!\\),/,$2))?1:1) && # parameters
			\!(grep($file =~ /^$_$/, (values(%SiteUP::TEMPLATES), $SITEUPSKIN))) && # do not frame siteup html templates
			$SiteUP::QUICKEDIT && # quick edit mode enabled
			($filename = &FindHTMLFile($file)) && # file with path
			(($filename =~ /^.*(\\|\/)(.*)/)?($file=$2):(1)) && # remove path - $file
			($filenamejs = $filename) && # file with path for java scripts
			(($filenamejs=~s/\\/\\\\/g)?(1):(1)) &&
			(($filenamejs=~s/\,/\\,/g)?(1):(1))
		)
		? # yes
		(
			&EvalDirective("INC:".
				(
					# online editable block?
					($SiteUP::INLINEQUICKEDIT && &IsBlockInlineEditable($filename))
					# yes
					?($SiteUP::TEMPLATES{begineditblock})
					# no
					:($SiteUP::TEMPLATES{beginblock}))
						# file, filename and js filename
						."|$file,$filename,$filenamejs"
				)
			.&ReadAndParseFile($filename,@params)
			.&EvalDirective("INC:$SiteUP::TEMPLATES{endblock}")
		)
		: # no
		(&ReadAndParseFile($file,@params))
	)!se;
	#
	# include files w/o parsing [%INL:file_name%]
	return $directive if $directive =~ s!^INL:(.+)$!(
		# Site-UP links?
		(
			($file = $1) && # file w/o path
			\!(grep($file =~ /^$_$/, (values(%SiteUP::TEMPLATES), $SITEUPSKIN))) && # do not frame siteup html templates
			$SiteUP::QUICKEDIT && # quick edit mode enabled
			($filename = &FindHTMLFile($file)) && # file with path
			(($filename =~ /^.*(\\|\/)(.*)/)?($file=$2):(1)) && # remove path - $file
			($filenamejs = $filename) && # file with path for java scripts
			(($filenamejs=~s/\\/\\\\/g)?(1):(1)) &&
			(($filenamejs=~s/\,/\\,/g)?(1):(1))
		)
		? # yes
		(
			&EvalDirective("INC:$SiteUP::TEMPLATES{beginblock}|$file,$filename,$filenamejs")
			.&ReadFileNoParse($filename)
			.&EvalDirective("INC:$SiteUP::TEMPLATES{endblock}")
		)
		# no
		:(&ReadFileNoParse($file))
	)!se;
	#
	# require module [%REQ:file_name|params_divided_by_commas%]
	return $directive if $directive =~ s!^REQ:([^|]+)\|?(.*)$!(
		# Site-UP links?
		(
			($file = $1) && # file w/o path
			((@params = split(/(?<\!\\),/,$2))?1:1) && # parameters
			\!(grep($file =~ /^$_$/, (values(%SiteUP::TEMPLATES), $SITEUPSKIN))) && # do not frame siteup html templates
			$SiteUP::QUICKEDIT && # quick edit mode enabled
			($filename = &FindPerlFile($file)) && # file with path
			(($filename =~ /^.*(\\|\/)(.*)/)?($file=$2):(1)) && # remove path - $file
			($filenamejs = $filename) && # file with path for java scripts
			(($filenamejs=~s/\\/\\\\/g)?(1):(1)) &&
			(($filenamejs=~s/\,/\\,/g)?(1):(1))
		)
		? # yes
		(
			&EvalDirective("INC:$SiteUP::TEMPLATES{beginblock}|$file,$filename,$filenamejs")
			.&RequireAndParseFile($filename,@params)
			.&EvalDirective("INC:$SiteUP::TEMPLATES{endblock}")
		)
		# no
		:(&RequireAndParseFile($file,@params))
	)!se;
	return "&#91;%$directive%&#93;";
}
sub HTMLFormating
{
	my ($content) = @_;
	$content =~ s/\&/&#38;/g;
	$content =~ s/\</&#60;/g;
	$content =~ s/\>/&#62;/g;
	$content =~ s/\[/&#91;/g;
	$content =~ s/\]/&#93;/g;
	$content =~ s/\%/&#37;/g;
	$content =~ s/\"/&#34;/g;
	$content =~ s/\'/&#39;/g;
	$content =~ s/\,/&#44;/g;
	$content =~ s/\?/&#63;/g;
	$content =~ s/\:/&#58;/g;
	return $content;
}
sub RemoveHTMLFormat
{
	my ($content) = @_;
	$content =~ s/\&\#(\d+)\;/pack("C", $1)/ge;
	return $content;
}
sub ReplaceCommas
{
	my ($content) = @_;
	$content =~ s/\,/&#44;/g;
	return $content;
}
sub RemoveDirectives
{
	my ($content) = @_;
	1	while $content =~ s/(\[|\<)%(([^%]*(?<!(\[|\<))%*(?!(\]|\>))[^%]*)+)%(\]|\>)//se;
	return $content;
}
sub ReadFile
{
	my ($file) = @_;
	my ($result) = "File not found: $file";
	if (-e $file)
	{
		local *FILE;
		open FILE, "$file";
		$result = join('', <FILE>);
		close FILE;
	}
	$result =~ s/\n\r/\n/g;
	$result =~ s/\r/\n/g;
	return $result;
}
sub RequireFile
{
	my ($file, @params) = @_;
	@_ = @params; $_ = '';
	eval('require "$file"');
	delete $INC{"$file"};
	if ($@) { push (@PERLERRORS, $@); return $@; }
	return $_;
}
sub RunFile
{
	my ($file) = @_;
	return scalar qx{$file 2>&1};
}
sub GetUrl
{
	my ($url) = @_;
	$url =~ /^.*(\\|\/)(.*)/;
	eval('use HTTP::Lite;');
	if ($@) { push (@PERLERRORS, $@); return $@; }
	my $http = new HTTP::Lite;
	my $status = $http->request($url) or return "Can not download via HTTP URL $url: $!";
	if ($status ne '200') { return "Can not download via HTTP URL $url: ".$http->status_message() }
	return $http->body();
}
sub ReadFileNoParse
{
	my ($file) = @_;
	return &HTMLFormating(&ReadFile(&FindHTMLFile($file)));
}
sub ReadAndParseFile
{
	my ($file, @params) = @_;
	return &Parse(&ReadFile(&FindHTMLFile($file)), @params);
}
sub RequireAndParseFile
{
	my ($file, @params) = @_;
	return &Parse(&RequireFile(&FindPerlFile($file), @params))
}
sub RunFileNoParse
{
	my ($file) = @_;
	return &HTMLFormating(&RunFile($file))
}
sub RunAndParseFile
{
	my ($file) = @_;
	return &Parse(&RunFile($file))
}
sub GetUrlNoParse
{
	my ($url) = @_;
	return &HTMLFormating(&GetUrl($url))
}
sub GetAndParseUrl
{
	my ($url) = @_;
	return &Parse(&GetUrl($url))
}
sub FindHTMLFile
{
	my ($file) = @_;
	foreach my $dir(@INCHTML)
	{
		return "$dir$DS($Language::LANGUAGE)$file" if ($Language::LANGUAGE and -e "$dir$DS($Language::LANGUAGE)$file");
		return "$dir$DS$file" if -e "$dir$DS$file";
	}
	if ($file =~ /^(.*)(\\|\/)(.*)$/)
	{
		my ($dir, $file) = ($1, $3);
		return "$dir$DS($Language::LANGUAGE)$file" if ($Language::LANGUAGE and -e "$dir$DS($Language::LANGUAGE)$file");
		return "$dir$DS$file" if -e "$dir$DS$file";
	}
	return $file;
}
sub FindPerlFile
{
	my ($file) = @_;
	foreach my $dir(@INC)
	{
		return "$dir$DS($Language::LANGUAGE)$file" if ($Language::LANGUAGE and -e "$dir$DS($Language::LANGUAGE)$file");
		return "$dir$DS$file" if -e "$dir$DS$file";
	}
	if ($file =~ /^(.*)(\\|\/)(.*)$/)
	{
		my ($dir, $file) = ($1, $3);
		return "$dir$DS($Language::LANGUAGE)$file" if ($Language::LANGUAGE and -e "$dir$DS($Language::LANGUAGE)$file");
		return "$dir$DS$file" if -e "$dir$DS$file";
	}
	return $file;
}
sub IsBlockInlineEditable
{
	my ($filename) = @_;
	my ($content, $top, $bot) = ();
	if (-e $filename)
	{
		local *FILE;
		open FILE, "$filename";
		binmode('FILE'); grep ($content .= $_, <FILE>); close FILE;
		close FILE;
		# is there start keyword of editable content?
		if ($content =~ s/^(.*)($SiteUP::STARTOFEDITABLECONTENT)//s) { $top = $1 } else { return 0; }
		# is there end keyword of editable content?
		if ($content =~ s/($SiteUP::ENDOFEDITABLECONTENT)(.*)$//s) { $bot = $2 } else { return 0; }
		# are there directives in the content?
		if ($content =~ /(\[|\<)%.+%(\]|\>)/g) { return 0; }
		# remove SET, ADD and comments directives in the top
		$top =~ s/(\[|\<)%SET\:.+%(\]|\>)//g;
		$top =~ s/(\[|\<)%ADD\:.+%(\]|\>)//g;
		$top =~ s/(\[|\<)%\#.*%(\]|\>)//g;
		# if not empty
		if ($top =~ /[^\s\n\t\r]/s) { return 0; }
		# remove SET and comments directives in the bottomm
		$bot =~ s/(\[|\<)%SET\:.+%(\]|\>)//g;
		$bot =~ s/(\[|\<)%\#.*%(\]|\>)//g;
		# if not empty
		if ($bot =~ /[^\s\n\t\r]/s) { return 0; }
		return 1;
	}
	return 0;
}

